# python build stubs for package client
# File is generated by gopy. Do not edit.
# gopy build -output=tinfoil_verifier -vm=python3 github.com/tinfoilsh/verifier/client

from pybindgen import retval, param, Function, Module
import sys

class CheckedFunction(Function):
    def __init__(self, *a, **kw):
        super(CheckedFunction, self).__init__(*a, **kw)
        self._failure_expression = kw.get('failure_expression', '')
        self._failure_cleanup = kw.get('failure_cleanup', '')

    def set_failure_expression(self, expr):
        self._failure_expression = expr

    def set_failure_cleanup(self, expr):
        self._failure_cleanup = expr

    def generate_call(self):
        super(CheckedFunction, self).generate_call()
        check = "PyErr_Occurred()"
        if self._failure_expression:
            check = "{} && {}".format(self._failure_expression, check)
        failure_cleanup = self._failure_cleanup or None
        self.before_call.write_error_check(check, failure_cleanup)

def add_checked_function(mod, name, retval, params, failure_expression='', *a, **kw):
    fn = CheckedFunction(name, retval, params, *a, **kw)
    fn.set_failure_expression(failure_expression)
    mod._add_function_obj(fn)
    return fn

def add_checked_string_function(mod, name, retval, params, failure_expression='', *a, **kw):
    fn = CheckedFunction(name, retval, params, *a, **kw)
    fn.set_failure_cleanup('if (retval != NULL) free(retval);')
    fn.after_call.add_cleanup_code('free(retval);')
    fn.set_failure_expression(failure_expression)
    mod._add_function_obj(fn)
    return fn

mod = Module('_client')
mod.add_include('"client_go.h"')
mod.add_function('GoPyInit', None, [])
mod.add_function('DecRef', None, [param('int64_t', 'handle')])
mod.add_function('IncRef', None, [param('int64_t', 'handle')])
mod.add_function('NumHandles', retval('int'), [])
mod.add_function('pkix_RelativeDistinguishedNameSET_CTor', retval('int64_t'), [])
mod.add_function('pkix_RelativeDistinguishedNameSET_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('pkix_RelativeDistinguishedNameSET_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('pkix_RelativeDistinguishedNameSET_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('pkix_RelativeDistinguishedNameSET_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('pkix_RelativeDistinguishedNameSET_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('asn1_ObjectIdentifier_CTor', retval('int64_t'), [])
mod.add_function('asn1_ObjectIdentifier_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('asn1_ObjectIdentifier_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('asn1_ObjectIdentifier_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('asn1_ObjectIdentifier_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('asn1_ObjectIdentifier_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('asn1_RawContent_CTor', retval('int64_t'), [])
mod.add_function('asn1_RawContent_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('asn1_RawContent_elem', retval('uint8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('asn1_RawContent_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('asn1_RawContent_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint8_t', 'value')])
mod.add_function('asn1_RawContent_append', None, [param('int64_t', 'handle'), param('uint8_t', 'value')])
mod.add_function('net_IP_CTor', retval('int64_t'), [])
mod.add_function('net_IP_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('net_IP_elem', retval('uint8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('net_IP_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('net_IP_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint8_t', 'value')])
mod.add_function('net_IP_append', None, [param('int64_t', 'handle'), param('uint8_t', 'value')])
mod.add_function('net_IPMask_CTor', retval('int64_t'), [])
mod.add_function('net_IPMask_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('net_IPMask_elem', retval('uint8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('net_IPMask_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('net_IPMask_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint8_t', 'value')])
mod.add_function('net_IPMask_append', None, [param('int64_t', 'handle'), param('uint8_t', 'value')])
mod.add_function('http_Header_CTor', retval('int64_t'), [])
mod.add_function('http_Header_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('http_Header_elem', retval('int64_t'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('http_Header_contains', retval('bool'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('http_Header_set', None, [param('int64_t', 'handle'), param('char*', 'key'), param('int64_t', 'value')])
mod.add_function('http_Header_delete', None, [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('http_Header_keys', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('textproto_MIMEHeader_CTor', retval('int64_t'), [])
mod.add_function('textproto_MIMEHeader_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('textproto_MIMEHeader_elem', retval('int64_t'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('textproto_MIMEHeader_contains', retval('bool'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('textproto_MIMEHeader_set', None, [param('int64_t', 'handle'), param('char*', 'key'), param('int64_t', 'value')])
mod.add_function('textproto_MIMEHeader_delete', None, [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('textproto_MIMEHeader_keys', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('url_Values_CTor', retval('int64_t'), [])
mod.add_function('url_Values_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('url_Values_elem', retval('int64_t'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('url_Values_contains', retval('bool'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('url_Values_set', None, [param('int64_t', 'handle'), param('char*', 'key'), param('int64_t', 'value')])
mod.add_function('url_Values_delete', None, [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('url_Values_keys', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('Slice_bool_CTor', retval('int64_t'), [])
mod.add_function('Slice_bool_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_bool_elem', retval('bool'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_bool_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_bool_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('bool', 'value')])
mod.add_function('Slice_bool_append', None, [param('int64_t', 'handle'), param('bool', 'value')])
mod.add_function('Slice_byte_CTor', retval('int64_t'), [])
mod.add_function('Slice_byte_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_byte_elem', retval('uint8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_byte_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_byte_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint8_t', 'value')])
mod.add_function('Slice_byte_append', None, [param('int64_t', 'handle'), param('uint8_t', 'value')])
mod.add_function('Slice_byte_from_bytes', retval('int64_t'), [param('PyObject*', 'o', transfer_ownership=False)])
mod.add_function('Slice_byte_to_bytes', retval('PyObject*', caller_owns_return=True), [param('int64_t', 'handle')])
mod.add_function('Slice_error_CTor', retval('int64_t'), [])
mod.add_function('Slice_error_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_error_elem', retval('char*'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_error_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_error_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('char*', 'value')])
mod.add_function('Slice_error_append', None, [param('int64_t', 'handle'), param('char*', 'value')])
mod.add_function('Slice_float32_CTor', retval('int64_t'), [])
mod.add_function('Slice_float32_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_float32_elem', retval('float'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_float32_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_float32_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('float', 'value')])
mod.add_function('Slice_float32_append', None, [param('int64_t', 'handle'), param('float', 'value')])
mod.add_function('Slice_float64_CTor', retval('int64_t'), [])
mod.add_function('Slice_float64_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_float64_elem', retval('double'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_float64_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_float64_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('double', 'value')])
mod.add_function('Slice_float64_append', None, [param('int64_t', 'handle'), param('double', 'value')])
mod.add_function('Slice_int_CTor', retval('int64_t'), [])
mod.add_function('Slice_int_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_int_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_int16_CTor', retval('int64_t'), [])
mod.add_function('Slice_int16_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int16_elem', retval('int16_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int16_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int16_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int16_t', 'value')])
mod.add_function('Slice_int16_append', None, [param('int64_t', 'handle'), param('int16_t', 'value')])
mod.add_function('Slice_int32_CTor', retval('int64_t'), [])
mod.add_function('Slice_int32_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int32_elem', retval('int32_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int32_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int32_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int32_t', 'value')])
mod.add_function('Slice_int32_append', None, [param('int64_t', 'handle'), param('int32_t', 'value')])
mod.add_function('Slice_int64_CTor', retval('int64_t'), [])
mod.add_function('Slice_int64_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int64_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int64_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int64_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_int64_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_int8_CTor', retval('int64_t'), [])
mod.add_function('Slice_int8_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int8_elem', retval('int8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int8_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int8_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int8_t', 'value')])
mod.add_function('Slice_int8_append', None, [param('int64_t', 'handle'), param('int8_t', 'value')])
mod.add_function('Slice_rune_CTor', retval('int64_t'), [])
mod.add_function('Slice_rune_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_rune_elem', retval('int32_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_rune_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_rune_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int32_t', 'value')])
mod.add_function('Slice_rune_append', None, [param('int64_t', 'handle'), param('int32_t', 'value')])
mod.add_function('Slice_string_CTor', retval('int64_t'), [])
mod.add_function('Slice_string_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_string_elem', retval('char*'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_string_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_string_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('char*', 'value')])
mod.add_function('Slice_string_append', None, [param('int64_t', 'handle'), param('char*', 'value')])
mod.add_function('Slice_uint_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint_elem', retval('uint64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint64_t', 'value')])
mod.add_function('Slice_uint_append', None, [param('int64_t', 'handle'), param('uint64_t', 'value')])
mod.add_function('Slice_uint16_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint16_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint16_elem', retval('uint16_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint16_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint16_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint16_t', 'value')])
mod.add_function('Slice_uint16_append', None, [param('int64_t', 'handle'), param('uint16_t', 'value')])
mod.add_function('Slice_uint32_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint32_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint32_elem', retval('uint32_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint32_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint32_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint32_t', 'value')])
mod.add_function('Slice_uint32_append', None, [param('int64_t', 'handle'), param('uint32_t', 'value')])
mod.add_function('Slice_uint64_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint64_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint64_elem', retval('uint64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint64_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint64_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint64_t', 'value')])
mod.add_function('Slice_uint64_append', None, [param('int64_t', 'handle'), param('uint64_t', 'value')])
mod.add_function('Slice_uint8_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint8_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint8_elem', retval('uint8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint8_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint8_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint8_t', 'value')])
mod.add_function('Slice_uint8_append', None, [param('int64_t', 'handle'), param('uint8_t', 'value')])
mod.add_function('Slice_Ptr_x509_Certificate_CTor', retval('int64_t'), [])
mod.add_function('Slice_Ptr_x509_Certificate_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_Ptr_x509_Certificate_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_Ptr_x509_Certificate_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_Ptr_x509_Certificate_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_Ptr_x509_Certificate_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_Ptr_multipart_FileHeader_CTor', retval('int64_t'), [])
mod.add_function('Slice_Ptr_multipart_FileHeader_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_Ptr_multipart_FileHeader_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_Ptr_multipart_FileHeader_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_Ptr_multipart_FileHeader_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_Ptr_multipart_FileHeader_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_Ptr_net_IPNet_CTor', retval('int64_t'), [])
mod.add_function('Slice_Ptr_net_IPNet_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_Ptr_net_IPNet_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_Ptr_net_IPNet_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_Ptr_net_IPNet_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_Ptr_net_IPNet_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_Ptr_http_Cookie_CTor', retval('int64_t'), [])
mod.add_function('Slice_Ptr_http_Cookie_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_Ptr_http_Cookie_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_Ptr_http_Cookie_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_Ptr_http_Cookie_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_Ptr_http_Cookie_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_Ptr_url_URL_CTor', retval('int64_t'), [])
mod.add_function('Slice_Ptr_url_URL_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_Ptr_url_URL_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_Ptr_url_URL_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_Ptr_url_URL_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_Ptr_url_URL_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_Slice_Ptr_x509_Certificate_CTor', retval('int64_t'), [])
mod.add_function('Slice_Slice_Ptr_x509_Certificate_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_Slice_Ptr_x509_Certificate_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_Slice_Ptr_x509_Certificate_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_Slice_Ptr_x509_Certificate_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_Slice_Ptr_x509_Certificate_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_Slice_byte_CTor', retval('int64_t'), [])
mod.add_function('Slice_Slice_byte_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_Slice_byte_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_Slice_byte_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_Slice_byte_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_Slice_byte_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_x509_ExtKeyUsage_CTor', retval('int64_t'), [])
mod.add_function('Slice_x509_ExtKeyUsage_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_x509_ExtKeyUsage_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_x509_ExtKeyUsage_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_x509_ExtKeyUsage_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_x509_ExtKeyUsage_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_x509_OID_CTor', retval('int64_t'), [])
mod.add_function('Slice_x509_OID_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_x509_OID_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_x509_OID_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_x509_OID_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_x509_OID_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_pkix_AttributeTypeAndValue_CTor', retval('int64_t'), [])
mod.add_function('Slice_pkix_AttributeTypeAndValue_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_pkix_AttributeTypeAndValue_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_pkix_AttributeTypeAndValue_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_pkix_AttributeTypeAndValue_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_pkix_AttributeTypeAndValue_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_pkix_Extension_CTor', retval('int64_t'), [])
mod.add_function('Slice_pkix_Extension_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_pkix_Extension_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_pkix_Extension_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_pkix_Extension_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_pkix_Extension_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_pkix_RevokedCertificate_CTor', retval('int64_t'), [])
mod.add_function('Slice_pkix_RevokedCertificate_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_pkix_RevokedCertificate_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_pkix_RevokedCertificate_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_pkix_RevokedCertificate_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_pkix_RevokedCertificate_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_asn1_ObjectIdentifier_CTor', retval('int64_t'), [])
mod.add_function('Slice_asn1_ObjectIdentifier_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_asn1_ObjectIdentifier_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_asn1_ObjectIdentifier_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_asn1_ObjectIdentifier_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_asn1_ObjectIdentifier_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_big_Word_CTor', retval('int64_t'), [])
mod.add_function('Slice_big_Word_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_big_Word_elem', retval('uint64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_big_Word_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_big_Word_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint64_t', 'value')])
mod.add_function('Slice_big_Word_append', None, [param('int64_t', 'handle'), param('uint64_t', 'value')])
mod.add_function('Slice_net_IP_CTor', retval('int64_t'), [])
mod.add_function('Slice_net_IP_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_net_IP_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_net_IP_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_net_IP_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_net_IP_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Map_string_Slice_Ptr_multipart_FileHeader_CTor', retval('int64_t'), [])
mod.add_function('Map_string_Slice_Ptr_multipart_FileHeader_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Map_string_Slice_Ptr_multipart_FileHeader_elem', retval('int64_t'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_Slice_Ptr_multipart_FileHeader_contains', retval('bool'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_Slice_Ptr_multipart_FileHeader_set', None, [param('int64_t', 'handle'), param('char*', 'key'), param('int64_t', 'value')])
mod.add_function('Map_string_Slice_Ptr_multipart_FileHeader_delete', None, [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_Slice_Ptr_multipart_FileHeader_keys', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('Map_string_Slice_string_CTor', retval('int64_t'), [])
mod.add_function('Map_string_Slice_string_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Map_string_Slice_string_elem', retval('int64_t'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_Slice_string_contains', retval('bool'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_Slice_string_set', None, [param('int64_t', 'handle'), param('char*', 'key'), param('int64_t', 'value')])
mod.add_function('Map_string_Slice_string_delete', None, [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_Slice_string_keys', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('Map_string_bool_CTor', retval('int64_t'), [])
mod.add_function('Map_string_bool_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Map_string_bool_elem', retval('bool'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_bool_contains', retval('bool'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_bool_set', None, [param('int64_t', 'handle'), param('char*', 'key'), param('bool', 'value')])
mod.add_function('Map_string_bool_delete', None, [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_bool_keys', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('Map_string_string_CTor', retval('int64_t'), [])
mod.add_function('Map_string_string_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Map_string_string_elem', retval('char*'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_string_contains', retval('bool'), [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_string_set', None, [param('int64_t', 'handle'), param('char*', 'key'), param('char*', 'value')])
mod.add_function('Map_string_string_delete', None, [param('int64_t', 'handle'), param('char*', '_ky')])
mod.add_function('Map_string_string_keys', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('client_GroundTruth_CTor', retval('int64_t'), [])
mod.add_function('client_GroundTruth_CertFingerprint_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('client_GroundTruth_CertFingerprint_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('client_GroundTruth_Digest_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('client_GroundTruth_Digest_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('client_GroundTruth_Measurement_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('client_GroundTruth_Measurement_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('client_Response_CTor', retval('int64_t'), [])
mod.add_function('client_Response_Status_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('client_Response_Status_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('client_Response_StatusCode_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('client_Response_StatusCode_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('client_Response_Body_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('client_Response_Body_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('client_SecureClient_CTor', retval('int64_t'), [])
add_checked_function(mod, 'client_SecureClient_GroundTruth', retval('int64_t'), [param('int64_t', '_handle')])
add_checked_function(mod, 'client_SecureClient_Verify', retval('int64_t'), [param('int64_t', '_handle')])
add_checked_function(mod, 'client_SecureClient_HTTPClient', retval('int64_t'), [param('int64_t', '_handle')])
add_checked_function(mod, 'client_SecureClient_Post', retval('int64_t'), [param('int64_t', '_handle'), param('char*', 'url'), param('int64_t', 'headers'), param('int64_t', 'body')])
add_checked_function(mod, 'client_SecureClient_Get', retval('int64_t'), [param('int64_t', '_handle'), param('char*', 'url'), param('int64_t', 'headers')])
mod.add_function('client_TLSBoundRoundTripper_CTor', retval('int64_t'), [])
mod.add_function('client_TLSBoundRoundTripper_ExpectedCertFP_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('client_TLSBoundRoundTripper_ExpectedCertFP_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
add_checked_function(mod, 'client_TLSBoundRoundTripper_RoundTrip', retval('int64_t'), [param('int64_t', '_handle'), param('int64_t', 'r')])
add_checked_function(mod, 'client_NewSecureClient', retval('int64_t'), [param('char*', 'enclave'), param('char*', 'repo')])

mod.generate(open('client.c', 'w'))

